'use strict';

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Licensed Materials - Property of IBM
 * IBM Cognos Products: BI Cloud (C) Copyright IBM Corp. 2021
 * US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */
define(['original/dashboard-analytics/drill-through/managers/DrillThroughMappingManager'], function (OriginalDrillThroughMappingManager) {
	var DrillThroughMappingManager = function (_OriginalDrillThrough) {
		_inherits(DrillThroughMappingManager, _OriginalDrillThrough);

		function DrillThroughMappingManager() {
			_classCallCheck(this, DrillThroughMappingManager);

			return _possibleConstructorReturn(this, _OriginalDrillThrough.apply(this, arguments));
		}

		DrillThroughMappingManager.prototype._collectWidgetMetadata = function _collectWidgetMetadata(contentId, sourceId) {
			var metadataIds = [];
			var content = this.dashboard.getFeature('Canvas').getContent(contentId);
			if (content) {
				//we should exclude the content where visualization does not exist
				var visualization = content.getFeature('Visualization');
				if (visualization) {
					var dataSource = visualization.getDataSource();
					if (dataSource && dataSource.getId() === sourceId) {
						var slots = visualization.getSlots();
						slots.getDataItemList().forEach(function (dataItem) {
							var metadataColumn = dataItem.getMetadataColumn();
							if (metadataColumn) {
								metadataIds.push(metadataColumn.getId());
							}
						});
					}
				}
			}
			return metadataIds;
		};

		return DrillThroughMappingManager;
	}(OriginalDrillThroughMappingManager);

	return DrillThroughMappingManager;
});